﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.IO;

namespace example
{
    public partial class Form1 : Form
    {
        [DllImport("tifftopdf.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern int MBegin();

        [DllImport("tifftopdf.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern int MAddFiles(int id,string infile);

        [DllImport("tifftopdf.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern int MConvert(int id,string output);

        [DllImport("tifftopdf.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern int MEncrypt(int id, string userpassword, string ownerpassword,int encryptlevel, int printing, int copying, int changing);

        [DllImport("tifftopdf.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern int MInformation(int id, string title, string subject, string author,string keywords, string creator, string producer);

        [DllImport("tifftopdf.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern int MWatermark(int id, string text, int fsize, int fcolor,int position);

        [DllImport("tifftopdf.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern int MEnd(int id);

        [DllImport("tifftopdf.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern int MSetParam(int id, int index, string sparam, string sparam2, int iparam, int iparam2);

        const int PARAM_DPI		 = 100;
        const int PARAM_SKEW	 = 101;
        const int PARAM_BOOKMARK = 102;
        const int PARAM_ROTATE = 103;
        const int PARAM_PAGESIZE = 104;
        const int PARAM_CTIFF = 105;
        const int PARAM_GTIFF = 106;
        const int PARAM_BWTIFF = 107;

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string appPath = Path.GetDirectoryName(Application.ExecutablePath);
            string inFile1 = appPath + "\\tif.tif";
            string inFile2 = appPath + "\\tif2.tif";
            string outFile = appPath + "\\combine.pdf";             
            
            int id = MBegin();    
            if(id>0)
            {
                int level = 40;
                int printing = 1;
                int copying = 1;
                int changing = 0;
                //Set PDF Encrypt
                MEncrypt(id, "password", "password2", level, printing, copying, changing);

                int bookmark = 2;
                //1 = use the page number as bookmarks.
                //2 = use the short filename as bookmarks.
                //3 = use the full filename as bookmarks.
                MSetParam(id, PARAM_BOOKMARK, "", "", bookmark, 0);

                int imgPosition = 3;
                //1 = Fit page 
                //2 = Stretch page 
                //3	= Center page
                //e.g MSetParam(id,PARAM_PAGESIZE,"600","800",imgPosition,0);
                MSetParam(id, PARAM_PAGESIZE, "a4", "", imgPosition, 0);

                //jpeg compress arithmetic, and 80 quality
                MSetParam(id, PARAM_CTIFF, "jpeg", "", 80, 0);

                //Add files
                MAddFiles(id, inFile1);
                MAddFiles(id, inFile2);

                //Combine all files into one pdf file
                MConvert(id, outFile);
	            MEnd(id);
	        }	
	        MessageBox.Show("Convert finished!");
        }

        private void button2_Click(object sender, EventArgs e)
        {
            string appPath = Path.GetDirectoryName(Application.ExecutablePath);

            string inFile1 = appPath + "\\tif.tif";
            string inFile2 = appPath + "\\tif2.tif";
            string outPath = appPath + "\\outpath\\";              
            
            int id = MBegin();
            if (id > 0)
            {
                int fsize = 16;
                int fcolor = 255;//red
                int position = 2;//Top-Center
                //Stamping
                MWatermark(id, "Watermark", fsize, fcolor, position);

                //Set PDF Information
                MInformation(id, "title", "subject", "author", "keywords", "creator", "producer");

                //Skew correct for black/white tiff file. 
                MSetParam(id, PARAM_SKEW, "", "", 1, 0);

                //Set Dpi 150
                MSetParam(id, PARAM_DPI, "", "", 150, 0);

                //rotate page 90
                MSetParam(id, PARAM_ROTATE, "", "", 90, 0);

                //Add files
                MAddFiles(id, inFile1);
                MAddFiles(id, inFile2);

                MConvert(id, outPath);
                MEnd(id);
            }
            MessageBox.Show("Convert finished!");
        }
    }
}
