//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void TForm1::GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}
//---------------------------------------------------------------------------
BOOL TForm1::LoadDll()
{
	char path[_MAX_PATH];
	GetModulePath(path,"tifftopdf.dll");	

	m_hinstLib = LoadLibrary(path);	
	if( m_hinstLib == NULL ){ 
		return FALSE;
	}

	pMBegin = (MBegin *)GetProcAddress(m_hinstLib, "MBegin");
	if( pMBegin == NULL ){
		FreeDll();
		return FALSE;
	}
	pMAddFiles = (MAddFiles *)GetProcAddress(m_hinstLib, "MAddFiles");
	if( pMAddFiles == NULL ){
		FreeDll(); 
		return FALSE;
	}
	pMConvert = (MConvert *)GetProcAddress(m_hinstLib, "MConvert");
	if( pMConvert == NULL ){ 
		FreeDll(); 
		return FALSE;
	}
	pMEncrypt = (MEncrypt *)GetProcAddress(m_hinstLib, "MEncrypt");
	if( pMEncrypt == NULL ){ 
		FreeDll(); 
		return FALSE;
	}
	pMInformation = (MInformation *)GetProcAddress(m_hinstLib, "MInformation");
	if( pMInformation == NULL ){ 
		FreeDll(); 
		return FALSE;
	}
	pMWatermark = (MWatermark *)GetProcAddress(m_hinstLib, "MWatermark");
	if( pMWatermark == NULL ){ 
		FreeDll(); 
		return FALSE;
	}
	pMEnd = (MEnd *)GetProcAddress(m_hinstLib, "MEnd");
	if( pMEnd == NULL ){ 
		FreeDll(); 
		return FALSE;
	}
	pMSetParam = (MSetParam *)GetProcAddress(m_hinstLib, "MSetParam");
	if( pMSetParam == NULL ){ 
		FreeDll(); 
		return FALSE;
	}

	return TRUE;
}
//---------------------------------------------------------------------------
BOOL TForm1::FreeDll()
{
	if( m_hinstLib ){
        FreeLibrary(m_hinstLib);
	}                 
	return TRUE;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
	if( LoadDll() == FALSE ){
		ShowMessage("Load tifftopdf.dll failed!");
		return;
	}

	char infile1[256],infile2[256];
	GetModulePath(infile1,"tif.tif");
	GetModulePath(infile2,"tif2.tif");

	char outfile[256];
	GetModulePath(outfile,"combine.pdf");	

	long id = pMBegin();
	if(id>0){
		long level = 40;
		long printing = 1;
		long copying = 1;
		long changing = 0;
		//Set PDF Encrypt
		pMEncrypt(id,"password","password2",level,printing,copying,changing);
		
		long bookmark=2;
		//1 = use the page number as bookmarks.
		//2 = use the short filename as bookmarks.
		//3 = use the full filename as bookmarks.
		pMSetParam(id,PARAM_BOOKMARK,NULL,NULL,bookmark,0);

		long imgPosition=3;
		//1 = Fit page 
		//2 = Stretch page 
		//3	= Center page
		//e.g pMSetParam(id,PARAM_PAGESIZE,"600","800",imgPosition,0);
		pMSetParam(id,PARAM_PAGESIZE,"a4",NULL,imgPosition,0);

		//jpeg compress arithmetic, and 80 quality
		pMSetParam(id,PARAM_CTIFF,"jpeg",NULL,80,0);

		//Add files
		pMAddFiles(id,infile1);
		pMAddFiles(id,infile2);

		//Combine all files into one pdf file
		pMConvert(id,outfile);
		pMEnd(id);
	}

	FreeDll();
	ShowMessage("Convert finished!");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
	if( LoadDll() == FALSE ){
		ShowMessage("Load tifftopdf.dll failed!");
		return;
	}

	char infile1[256],infile2[256];
	GetModulePath(infile1,"tif.tif");
	GetModulePath(infile2,"tif2.tif");

	char outpath[256];
	GetModulePath(outpath,"outpath\\");

	long id = pMBegin();
	if(id>0){
		long fsize=16;
		long fcolor=255;//red
		long position=2;//Top-Center
		//Stamping
		pMWatermark(id,"Watermark",fsize,fcolor,position);

		//Set PDF Information
		pMInformation(id,"title","subject","author","keywords","creator","producer");		

 		//Skew correct for black/white tiff file. 
		pMSetParam(id,PARAM_SKEW,NULL,NULL,1,0);

		//Set Dpi 150
		pMSetParam(id,PARAM_DPI,NULL,NULL,150,0);
		
		//rotate page 90
		pMSetParam(id,PARAM_ROTATE,NULL,NULL,90,0);

		//Add files
		pMAddFiles(id,infile1);
		pMAddFiles(id,infile2);

		pMConvert(id,outpath);
		pMEnd(id);
	}

	FreeDll();
	ShowMessage("Convert finished!");
}
//---------------------------------------------------------------------------
