unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

const
  PARAM_DPI		 = 100;
  PARAM_SKEW	 = 101;
  PARAM_BOOKMARK = 102;
  PARAM_ROTATE	 = 103;
  PARAM_PAGESIZE = 104;
  PARAM_CTIFF	 = 105;
  PARAM_GTIFF	 = 106;
  PARAM_BWTIFF	 = 107;

type
  MBegin = function():Longint; stdcall;
  MEnd = function(id:Longint):Longint; stdcall;
  MInformation = function(id:Longint;title:PChar;subject:PChar;author:PChar;keywords:PChar;creator:PChar;producer:PChar):Longint; stdcall;
  MEncrypt = function(id:Longint;userpassword:PChar;ownerpassword:PChar;encryptlevel:Longint;printing:Longint;copying:Longint;changing:Longint):Longint; stdcall;
  MConvert = function(id:Longint;outfile:PChar):Longint; stdcall;
  MAddFiles = function(id:Longint;infile:PChar):Longint; stdcall;
  MSetParam = function(id:Longint;index:Longint;sparam:PChar;sparam2:PChar;iparam:Longint;iparam2:Longint):Longint; stdcall;
  MWatermark = function(id:Longint;text:PChar;fsize:Longint;fcolor:Longint;position:Longint):Longint; stdcall;

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
    m_hDll:HMODULE;
		pMBegin:MBegin;
		pMEnd:MEnd;
    pMConvert:MConvert;
    pMAddFiles:MAddFiles;
    pMEncrypt:MEncrypt;
    pMInformation:MInformation;
    pMWatermark:MWatermark;
    pMSetParam:MSetParam;

    function LoadDLL():BOOL;
    function FreeDLL():BOOL;    
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
function TForm1.LoadDLL():BOOL;
var
   sDllFile: PAnsiChar;
   pFunc: FARPROC;
label
   ERR_FLAG;
begin
   sDllFile := 'tifftopdf.dll';
   m_hDll := LoadLibrary(sDllFile);
   if m_hDll = 0 then
   begin
      Result := FALSE;
      exit;
   end;

	 pFunc := GetProcAddress(m_hDll, 'MBegin');
	 if pFunc = nil then goto ERR_FLAG;
   pMBegin := pFunc;

	 pFunc := GetProcAddress(m_hDll, 'MEnd');
	 if pFunc = nil then goto ERR_FLAG;
   pMEnd := pFunc;

	 pFunc := GetProcAddress(m_hDll, 'MConvert');
	 if pFunc = nil then goto ERR_FLAG;
   pMConvert := pFunc;

	 pFunc := GetProcAddress(m_hDll, 'MAddFiles');
	 if pFunc = nil then goto ERR_FLAG;
   pMAddFiles := pFunc;

	 pFunc := GetProcAddress(m_hDll, 'MEncrypt');
	 if pFunc = nil then goto ERR_FLAG;
   pMEncrypt := pFunc;

	 pFunc := GetProcAddress(m_hDll, 'MInformation');
	 if pFunc = nil then goto ERR_FLAG;
   pMInformation := pFunc;

	 pFunc := GetProcAddress(m_hDll, 'MWatermark');
	 if pFunc = nil then goto ERR_FLAG;
   pMWatermark := pFunc;

	 pFunc := GetProcAddress(m_hDll, 'MSetParam');
	 if pFunc = nil then goto ERR_FLAG;
   pMSetParam := pFunc;

   Result := TRUE;
   exit;

ERR_FLAG:
   Result := FALSE;
end;

function TForm1.FreeDLL():BOOL;
begin
	if m_hDll <> 0  then
  begin
     FreeLibrary(m_hDll);
     m_hDll := 0;
  end;
	Result := TRUE;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  infile:PAnsiChar;
  infile2:PAnsiChar;
  outfile:PAnsiChar;
  id:Longint;

  level:Longint;
  printing:Longint;
  copying:Longint;
  changing:Longint;
  bookmark:Longint;
  imgPosition:Longint;
begin
	if LoadDLL() = FALSE then
  begin
    ShowMessage('Load tifftopdf.dll failed!');
		exit;
	end;

  infile := Pchar(ExtractFileDir(ParamStr(0))+'/tif.tif');
  infile2 := Pchar(ExtractFileDir(ParamStr(0))+'/tif2.tif');
  outfile := Pchar(ExtractFileDir(ParamStr(0))+'/combine.pdf');

  id := pMBegin();
	if id > 0 then
  begin
    level := 40;
    printing := 1;
    copying := 1;
    changing := 0;
    //Set PDF Encrypt
    pMEncrypt(id, 'password', 'password2', level, printing, copying, changing );

    bookmark := 2;
    //1 = use the page number as bookmarks.
    //2 = use the short filename as bookmarks.
    //3 = use the full filename as bookmarks.
    pMSetParam(id, PARAM_BOOKMARK, '', '', bookmark, 0);

    imgPosition := 3;
    //1 = Fit page
    //2 = Stretch page
    //3	= Center page
    //e.g pMSetParam(id,PARAM_PAGESIZE,'600','800',imgPosition,0)
    pMSetParam(id, PARAM_PAGESIZE, 'a4', '', imgPosition, 0);

    //jpeg compress arithmetic, and 80 quality
    pMSetParam(id, PARAM_CTIFF, 'jpeg', '', 80, 0);

    //Add files
    pMAddFiles(id, infile);
    pMAddFiles(id, infile2);

    //Combine all files into one pdf file
    pMConvert(id, outfile);
    pMEnd(id);
	end;
  FreeDLL();
  ShowMessage('Convert finished!');
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  infile:PAnsiChar;
  infile2:PAnsiChar;
  outpath:PAnsiChar;
  id:Longint;

  fsize:Longint;
  fcolor:Longint;
  position:Longint;
begin
	if LoadDLL() = FALSE then
  begin
    ShowMessage('Load tifftopdf.dll failed!');
		exit;
	end;

  infile := Pchar(ExtractFileDir(ParamStr(0))+'/tif.tif');
  infile2 := Pchar(ExtractFileDir(ParamStr(0))+'/tif2.tif');
  outpath := Pchar(ExtractFileDir(ParamStr(0))+'/outpath/');

  id := pMBegin();
	if id > 0 then
  begin
    fsize := 16;
    fcolor := 255; //red
    position := 2; //Top-Center
    pMWatermark(id, 'Watermark', fsize, fcolor, position);

    //Set PDF Information
    pMInformation(id, 'title', 'subject', 'author', 'keywords', 'creator', 'producer');

    //Skew correct for black/white tiff file.
    pMSetParam(id, PARAM_SKEW, '', '', 1, 0);

    //Set Dpi 150
    pMSetParam(id, PARAM_DPI, '', '', 150, 0);

    //rotate page 90
    pMSetParam(id, PARAM_ROTATE, '', '', 90, 0);

    //Add files
    pMAddFiles(id, infile);
    pMAddFiles(id, infile2);

    pMConvert(id, outPath);
    pMEnd(id);
	end;
  FreeDLL();
  ShowMessage('Convert finished!');  
end;

end.
 