﻿Public Class Form1
    Private Declare Function MBegin Lib "tifftopdf.dll" () As Integer
    Private Declare Function MAddFiles Lib "tifftopdf.dll" (ByVal id As Integer, ByVal infile As String) As Integer
    Private Declare Function MConvert Lib "tifftopdf.dll" (ByVal id As Integer, ByVal output As String) As Integer

    Private Declare Function MEncrypt Lib "tifftopdf.dll" (ByVal id As Integer, ByVal userpassword As String, ByVal ownerpassword As String,
                                                          ByVal encryptlevel As Integer, ByVal printing As Integer, ByVal copying As Integer,
                                                          ByVal changing As Integer) As Integer

    Private Declare Function MInformation Lib "tifftopdf.dll" (ByVal id As Integer, ByVal title As String, ByVal subject As String, ByVal author As String,
                                                         ByVal keywords As String, ByVal creator As String, ByVal producer As String) As Integer

    Private Declare Function MWatermark Lib "tifftopdf.dll" (ByVal id As Integer, ByVal text As String, ByVal fsize As Integer, ByVal fcolor As Integer,
                                                           ByVal position As Integer) As Integer

    Private Declare Function MEnd Lib "tifftopdf.dll" (ByVal id As Integer) As Integer

    Private Declare Function MSetParam Lib "tifftopdf.dll" (ByVal id As Integer, ByVal index As Integer, ByVal sparam As String, ByVal sparam2 As String, ByVal iparam As Integer, ByVal iparam2 As Integer) As Integer

    Const PARAM_DPI = 100
    Const PARAM_SKEW = 101
    Const PARAM_BOOKMARK = 102
    Const PARAM_ROTATE = 103
    Const PARAM_PAGESIZE = 104
    Const PARAM_CTIFF = 105
    Const PARAM_GTIFF = 106
    Const PARAM_BWTIFF = 107

    Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click
        Dim id As Integer
        Dim level As Integer
        Dim printing As Integer
        Dim copying As Integer
        Dim changing As Integer
        Dim bookmark As Integer
        Dim imgPosition As Integer

        Dim inFile As String = Application.StartupPath + "\tif.tif"
        Dim inFile2 As String = Application.StartupPath + "\tif2.tif"
        Dim outFile As String = Application.StartupPath + "\combine.pdf"

        id = MBegin()
        If (id > 0) Then
            level = 40
            printing = 1
            copying = 1
            changing = 0
            'Set PDF Encrypt
            MEncrypt(id, "password", "password2", level, printing, copying, changing)

            bookmark = 2
            '1 = use the page number as bookmarks.
            '2 = use the short filename as bookmarks.
            '3 = use the full filename as bookmarks.
            MSetParam(id, PARAM_BOOKMARK, "", "", bookmark, 0)

            imgPosition = 3
            '1 = Fit page 
            '2 = Stretch page 
            '3	= Center page
            'e.g MSetParam(id,PARAM_PAGESIZE,"600","800",imgPosition,0)
            MSetParam(id, PARAM_PAGESIZE, "a4", "", imgPosition, 0)

            'jpeg compress arithmetic, and 80 quality
            MSetParam(id, PARAM_CTIFF, "jpeg", "", 80, 0)

            'Add files
            MAddFiles(id, inFile)
            MAddFiles(id, inFile2)

            'Combine all files into one pdf file
            MConvert(id, outFile)
            MEnd(id)
        End If

        MsgBox("Convert finished!")
    End Sub

    Private Sub Button2_Click(sender As System.Object, e As System.EventArgs) Handles Button2.Click
        Dim id As Integer
        Dim fsize As Integer
        Dim fcolor As Integer
        Dim position As Integer

        Dim inFile As String = Application.StartupPath + "\tif.tif"
        Dim inFile2 As String = Application.StartupPath + "\tif2.tif"
        Dim outPath As String = Application.StartupPath + "\outpath\"

        id = MBegin()
        If (id > 0) Then
            fsize = 16
            fcolor = 255 'red
            position = 2 'Top-Center
            MWatermark(id, "Watermark", fsize, fcolor, position)

            'Set PDF Information
            MInformation(id, "title", "subject", "author", "keywords", "creator", "producer")

            'Skew correct for black/white tiff file. 
            MSetParam(id, PARAM_SKEW, "", "", 1, 0)

            'Set Dpi 150
            MSetParam(id, PARAM_DPI, "", "", 150, 0)

            'rotate page 90
            MSetParam(id, PARAM_ROTATE, "", "", 90, 0)

            'Add files
            MAddFiles(id, inFile)
            MAddFiles(id, inFile2)

            MConvert(id, outPath)
            MEnd(id)
        End If

        MsgBox("Convert finished!")
    End Sub
End Class
