// exampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "example.h"
#include "exampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CExampleDlg dialog

CExampleDlg::CExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CExampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CExampleDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExampleDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CExampleDlg, CDialog)
	//{{AFX_MSG_MAP(CExampleDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExampleDlg message handlers

BOOL CExampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CExampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CExampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
/////////////////////////////////////////////////////////////////////////////
void CExampleDlg::GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}
/////////////////////////////////////////////////////////////////////////////
BOOL CExampleDlg::LoadDll()
{
	char path[_MAX_PATH];
	GetModulePath(path,"tifftopdf.dll");	

	m_hinstLib = LoadLibrary(path);		
	if( m_hinstLib == NULL ){ 
		return FALSE;
	}

	pMBegin = (MBegin *)GetProcAddress(m_hinstLib, "MBegin");
	if( pMBegin == NULL ){ 
		FreeDll(); 
		return FALSE;
	}
	pMAddFiles = (MAddFiles *)GetProcAddress(m_hinstLib, "MAddFiles");
	if( pMAddFiles == NULL ){ 
		FreeDll(); 
		return FALSE;
	}
	pMConvert = (MConvert *)GetProcAddress(m_hinstLib, "MConvert");
	if( pMConvert == NULL ){ 
		FreeDll(); 
		return FALSE;
	}
	pMEncrypt = (MEncrypt *)GetProcAddress(m_hinstLib, "MEncrypt");
	if( pMEncrypt == NULL ){ 
		FreeDll(); 
		return FALSE;
	}
	pMInformation = (MInformation *)GetProcAddress(m_hinstLib, "MInformation");
	if( pMInformation == NULL ){ 
		FreeDll(); 
		return FALSE;
	}
	pMWatermark = (MWatermark *)GetProcAddress(m_hinstLib, "MWatermark");
	if( pMWatermark == NULL ){ 
		FreeDll(); 
		return FALSE;
	}
	pMEnd = (MEnd *)GetProcAddress(m_hinstLib, "MEnd");
	if( pMEnd == NULL ){ 
		FreeDll(); 
		return FALSE;
	}
	pMSetParam = (MSetParam *)GetProcAddress(m_hinstLib, "MSetParam");
	if( pMSetParam == NULL ){ 
		FreeDll(); 
		return FALSE;
	}
	return TRUE;
}
/////////////////////////////////////////////////////////////////////////////
BOOL CExampleDlg::FreeDll()
{
	if( m_hinstLib ){
        FreeLibrary(m_hinstLib);
	}
	return TRUE;
}
/////////////////////////////////////////////////////////////////////////////
void CExampleDlg::OnButton1() 
{
	if( LoadDll() == FALSE ){
		MessageBox("Load tifftopdf.dll failed!");
		return;
	}

	char infile1[256],infile2[256];
	GetModulePath(infile1,"tif.tif");
	GetModulePath(infile2,"tif2.tif");

	char outfile[256];
	GetModulePath(outfile,"combine.pdf");	

	long id = pMBegin();
	if(id>0){
		long level = 40;
		long printing = 1;
		long copying = 1;
		long changing = 0;
		//Set PDF Encrypt
		pMEncrypt(id,"password","password2",level,printing,copying,changing);
		
		long bookmark=2;
		//1 = use the page number as bookmarks.
		//2 = use the short filename as bookmarks.
		//3 = use the full filename as bookmarks.
		pMSetParam(id,PARAM_BOOKMARK,NULL,NULL,bookmark,0);

		long imgPosition=3;
		//1 = Fit page 
		//2 = Stretch page 
		//3	= Center page
		//e.g pMSetParam(id,PARAM_PAGESIZE,"600","800",imgPosition,0);
		pMSetParam(id,PARAM_PAGESIZE,"a4",NULL,imgPosition,0);

		//jpeg compress arithmetic, and 80 quality
		pMSetParam(id,PARAM_CTIFF,"jpeg",NULL,80,0);

		//Add files
		pMAddFiles(id,infile1);
		pMAddFiles(id,infile2);

		//Combine all files into one pdf file
		pMConvert(id,outfile);
		pMEnd(id);
	}	

	FreeDll();
	MessageBox("Convert finished!");
}
/////////////////////////////////////////////////////////////////////////////
void CExampleDlg::OnButton2() 
{
	if( LoadDll() == FALSE ){
		MessageBox("Load tifftopdf.dll failed!");
		return;
	}

	char infile1[256],infile2[256];
	GetModulePath(infile1,"tif.tif");
	GetModulePath(infile2,"tif2.tif");

	char outpath[256];
	GetModulePath(outpath,"outpath\\");

	long id = pMBegin();
	id = pMBegin();
	if(id>0){
		long fsize=16;
		long fcolor=255;//red
		long position=2;//Top-Center
		//Stamping
		pMWatermark(id,"Watermark",fsize,fcolor,position);

		//Set PDF Information
		pMInformation(id,"title","subject","author","keywords","creator","producer");		

		//Skew correct for black/white tiff file. 
		pMSetParam(id,PARAM_SKEW,NULL,NULL,1,0);

		//Set Dpi 150
		pMSetParam(id,PARAM_DPI,NULL,NULL,150,0);
		
		//rotate page 90
		pMSetParam(id,PARAM_ROTATE,NULL,NULL,90,0);

		//Add files
		pMAddFiles(id,infile1);
		pMAddFiles(id,infile2);

		pMConvert(id,outpath);
		pMEnd(id);
	}

	FreeDll();
	MessageBox("Convert finished!");
}
